{% extends 'base.html.twig' %}

{% block content %}
    <div class="row header bg-primary">
        <div class="mx-auto equipo">
            Editar partido
        </div>
    </div>
    <div id="main" class="row">
        <div id="selector" class="mx-auto">
            <select id="selectedMatch">
                <option value="none">Seleccione un partido</option>
                {% for item in matches%}
                    <option value="{{item.rivalName}}">{{item.rivalName}}</option>
                {% endfor%}
            </select>
        </div>
            
    </div>
    <div class="row">
        <div id="tableContent" class="mx-auto">
        </div>            
    </div>
    <div class="row">
        <div id="addEvent" class="mx-auto" style="display: none">
            <div>
                <label>Evento:</label>
                <select id="eventType">
                    <option value="none">Seleccione</option>
                    <option value="inicio">Inicio</option>
                    <option value="gol">Gol</option>
                    <option value="amarilla">Amarilla</option>
                    <option value="roja">Roja</option>
                    <option value="final">Final</option>
                </select>
            </div>
            <div>
                <label>Adarve:</label>
                <select id="selfPlayerList">
                    <option value="none">Seleccione</option>
                    {%for item in selfPlayers%}
                        <option value="{{item.name}}">{{item.name}}</option>
                    {%endfor%}
                </select>
                <label>Rival:</label>
                <select id="rivalPlayerList">
                    <!-- contenedor del selector de jugadores del equipo rival que se cargará por ajax cuando el equipo rival sea seleccionado -->
                </select>
            </div>
            <div>
                <label>Minuto:</label><input type='time' id="eventTime" name="eventTime" step="1" value="00:00:00">
            </div>
            <!-- -->
            <div>
                <input type='button' id="save" value="Guardar">
            </div>
            <div id="error" style="display: none">
                Error en formulario
            </div>
        </div>            
    </div>
{% endblock %}

{% block javascripts %}
    <script> // este código debería encontrarse en un fichero JS referenciado y no dentro del fichero html
        
        $('#save').on('click',function(){
            $('#error').hide();
            var rival = $('option:selected', $('#selectedMatch')).val();
            var event = $('option:selected', $('#eventType')).val();
            var selfPlayer = $('option:selected', $('#selfPlayerList')).val();
            var rivalPlayer = $('option:selected', $('#rivalPlayerList')).val();
            var time = $('#eventTime').val();
            console.log(event);
            console.log(selfPlayer);
            console.log(rivalPlayer);
            console.log(time);
            console.log(rival);
            if(event==='none' || (selfPlayer ==='none' && rivalPlayer ==='none') || time >= '01:40:00'){
{#                console.error('error');#}
                $('#error').show();
            }else{
                if(event==='inicio'){
                    time = '00:00:00';
                }
                $.ajax({
                url:'/api/saveEvent',
                type: 'POST',
                dataType: 'json',
                data:{
                    'rival':rival,
                    'event':event,
                    'selfPlayer':selfPlayer,
                    'rivalPlayer':rivalPlayer,
                    'time':time
                },
                success: function (response) {
                },
                error: function(errorThrown){
                         
                    }
                });
                $('#rivalPlayerList').find('option:first').attr('selected', 'selected')
                $('#selfPlayerList').find('option:first').attr('selected', 'selected')
                $('#eventType').find('option:first').attr('selected', 'selected')
            }
{#            location.reload();#}
            
            
        });
        
        //seleccionando una opción, se bloquea el otro selector
        $('#selfPlayerList').on('change', function(){
            if($('option:selected', this).val()!== 'none'){
                $('#rivalPlayerList').find('option:first').attr('selected', 'selected') // al cambiar, el otro selector vuelve a la posicion inicial
                $('#rivalPlayerList').attr('disabled',true);
            }else{
                $('#rivalPlayerList').attr('disabled',false); // seleccionando la primera opción, se desbloquea el otro
            }
        });
        //seleccionando una opción, se bloquea el otro selector
        $('#rivalPlayerList').on('change', function(){
            if($('option:selected', this).val()!== 'none'){
                $('#selfPlayerList').find('option:first').attr('selected', 'selected') // al cambiar, el otro selector vuelve a la posicion inicial
                $('#selfPlayerList').attr('disabled',true);
            }else{
                $('#selfPlayerList').attr('disabled',false); // seleccionando la primera opción, se desbloquea el otro
            }
        });
        // al cambiar el encuentro seleccionado, se cargan los eventos del partido
        $('#selectedMatch').on('change', function(){
            if($('option:selected', $('#selectedMatch')).val()!== 'none'){
           
                $('#addEvent').hide(); // se oculta el formulario de insercion de eventos para impedir que se vean los cambios en los campos
                var selectedTeam = $('option:selected', this).val(); // opcion seleccionada
                $("#tableContent").empty(); // se vacía la tabla del contenido existente
                $("#rivalPlayerList").empty(); // se vacía el selector de rivales, ya que cambia el equipo seleccionado
                // llamada al servicio que obtiene los datos del partido y que en una versión mejorada debería permitir conexiones remotas    
                $.ajax({
                    url:'/api/matchData',
                    type: 'POST',
                    dataType: 'json',
                    data:{
                        'rivalName':selectedTeam
                    },
                    success: function (response) {
                        if(response['allData'] !== null){
                            var longitud = Object.keys(response.allData).length; // obtención del límite del array para ejecutar el loop
                            // inicio estático de la tabla que contendrá los datos del partido
                            $('#tableContent').append('<table><thead><th>Evento</th><th>Jugador</th><th>Minuto</th></thead><tbody>')
                            for(var i=0; i<longitud;i++){
                                // tratamiento de la fecha para aislar horas, minutos y segundos
                                var datetime = new Date(response['allData'][i]['time']['date']);
                                var time = (datetime.getHours()>0?datetime.getHours()+':':'');
                                time += (datetime.getMinutes()<10?'0'+datetime.getMinutes()+':': datetime.getMinutes()+':');
                                time += (datetime.getSeconds()<10?'0'+datetime.getSeconds(): datetime.getSeconds());
                                // tratamiento del resultset para formar el cuerpo de la tabla
                                $("#tableContent").append('<tr class="' + response['allData'][i]['name'] + '">' +
                                    '<td>' +
                                    response['allData'][i]['name'] +
                                    '</td><td>' +
                                    response['allData'][i]['player'] +
                                    '</td><td>' +
                                    time +
                                    '</td>'
                                );

                            }
                            // cierre de la tabla
                            $('#tableContent').append('</tbody></table>');
                        }
                    },
                    timeout:30000,
                    error: function(errorThrown){

                        }
                  });
                  // llamada al servicio que obtiene los datos del equipo rival y que en una versión mejorada debería permitir conexiones remotas
                  $.ajax({
                    url:'/api/playerList',
                    type: 'POST',
                    dataType: 'json',
                    data:{
                        'rivalName':selectedTeam
                    },
                    success: function (response) {
                        if(response['rivalData'] !== null){
                            var longitud = Object.keys(response.rivalData).length; // obtención del límite del array para ejecutar el loop
                            $('#rivalPlayerList').append('<option value="none">Seleccione</option>')// inicio estático del selector de los nombres de jugadores del equipo rival
                            for(var i=0; i<longitud;i++){
                                // cuerpo del selector con los nombres de jugadores
                                $("#rivalPlayerList").append('<option value="' + response['rivalData'][i]['name'] + '">' +
                                    response['rivalData'][i]['name'] +
                                    ' (' +
                                    response['rivalData'][i]['team'] +
                                    ') ' +
                                    '</option>'
                                );

                            }
                        }
                    },
                    timeout:30000,
                    error: function(errorThrown){

                        }
                  });
                  setTimeout(function(){$('#addEvent').show();},1000); // se muestra el formulario de insercion de eventos una vez realizados los cambios
            }else{
                $('#addEvent').hide();
                $("#tableContent").empty();
            }
        });
             
    </script>
    
{% endblock %}

{% block stylesheets %}
    <style>
        select{
            min-width: 200px;
        }
        table{
            
            font-size: 20px;
        }
        tr, td, th{
            min-width: 100px;
            border: 1px solid black;
            text-align: center;
        }
        .gol{
            color: green;
        }
        .amarilla{
            color:orange;
        }
        .roja{
            color: red;
        }
        #error{
            color: red;
            font-size: 30px;
        }
    </style>
{% endblock %}